"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateItemMetadata = exports.parseItemMetadata = exports.generateItemMetadata = exports.itemSupportedVersionsTypeMapping = exports.itemSupportedVersions = exports.itemValidateVersion = exports.ItemMetadataTypes = void 0;
const tslib_1 = require("tslib");
const src_1 = require("@motif-foundation/item-metadata/dist/src");
Object.defineProperty(exports, "itemValidateVersion", { enumerable: true, get: function () { return src_1.validateVersion; } });
Object.defineProperty(exports, "itemSupportedVersions", { enumerable: true, get: function () { return src_1.supportedVersions; } });
Object.defineProperty(exports, "itemSupportedVersionsTypeMapping", { enumerable: true, get: function () { return src_1.supportedVersionsTypeMapping; } });
const ItemMetadataTypes = (0, tslib_1.__importStar)(require("@motif-foundation/item-metadata/dist/types/types"));
exports.ItemMetadataTypes = ItemMetadataTypes;
function generateItemMetadata(version, data) {
    const generator = new src_1.Generator(version);
    return generator.generateJSON(data);
}
exports.generateItemMetadata = generateItemMetadata;
function parseItemMetadata(version, json) {
    const parser = new src_1.Parser(version);
    return parser.parse(json);
}
exports.parseItemMetadata = parseItemMetadata;
function validateItemMetadata(version, data) {
    const validator = new src_1.Validator(version);
    return validator.validate(data);
}
exports.validateItemMetadata = validateItemMetadata;
//# sourceMappingURL=metadata.js.map