"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deployCurrency = exports.approveCurrency = exports.mintCurrency = exports.setupMotif = void 0;
const tslib_1 = require("tslib");
const typechain_1 = require("@motif-foundation/asset/dist/typechain");
const bignumber_1 = require("@ethersproject/bignumber");
const constants_1 = require("@ethersproject/constants");
function setupMotif(wallet, testWallets) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        const itemExchange = yield (yield new typechain_1.ItemExchangeFactory(wallet).deploy()).deployed();
        const itemExchangeAddress = itemExchange.address;
        const item = yield (yield new typechain_1.ItemFactory(wallet).deploy(itemExchange.address, "Motif", "MOTIF", 1000000)).deployed();
        const itemAddress = item.address;
        yield itemExchange.configure(itemAddress);
        const currency = yield (yield new typechain_1.BaseErc20Factory(wallet).deploy('TEST', 'TEST', bignumber_1.BigNumber.from(18))).deployed();
        const currencyAddress = currency.address;
        for (const toWallet of testWallets) {
            yield mintCurrency(wallet, currencyAddress, toWallet.address, bignumber_1.BigNumber.from('10000000000000000000000'));
            yield approveCurrency(toWallet, currencyAddress, itemExchangeAddress);
        }
        return {
            item: itemAddress,
            itemExchange: itemExchangeAddress,
            currency: currencyAddress,
        };
    });
}
exports.setupMotif = setupMotif;
function mintCurrency(wallet, tokenAdress, to, amount) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        return typechain_1.BaseErc20Factory.connect(tokenAdress, wallet).mint(to, amount);
    });
}
exports.mintCurrency = mintCurrency;
function approveCurrency(wallet, tokenAddress, to) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        return typechain_1.BaseErc20Factory.connect(tokenAddress, wallet).approve(to, constants_1.MaxUint256);
    });
}
exports.approveCurrency = approveCurrency;
function deployCurrency(wallet, name, symbol, decimals) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        const currency = yield (yield new typechain_1.BaseErc20Factory(wallet).deploy(name, symbol, bignumber_1.BigNumber.from(decimals))).deployed();
        return currency.address;
    });
}
exports.deployCurrency = deployCurrency;
//# sourceMappingURL=helpers.js.map